SystemOrganization addCategory: #'Announcements-Core'!
SystemOrganization addCategory: #'Announcements-View'!
SystemOrganization addCategory: #'Announcements-Tests'!

Set subclass: #AnnouncementSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!AnnouncementSet methodsFor: 'adding' stamp: 'lr 6/13/2006 08:13'!
, anAnnouncementClass
	self add: anAnnouncementClass! !

!AnnouncementSet methodsFor: 'testing' stamp: 'lr 10/3/2006 14:31'!
handles: anAnnouncementClass
	^ self anySatisfy: [ :each | each handles: anAnnouncementClass ]! !

Object subclass: #Announcement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!Announcement class methodsFor: 'public' stamp: 'lr 9/20/2006 08:18'!
, anAnnouncementClass
	^ AnnouncementSet with: self with: anAnnouncementClass! !

!Announcement class methodsFor: 'converting' stamp: 'lr 10/3/2006 14:31'!
asAnnouncement
	^ self new! !

!Announcement class methodsFor: 'testing' stamp: 'lr 10/3/2006 14:31'!
handles: anAnnouncementClass
	^ anAnnouncementClass isKindOf: self! !

!Announcement methodsFor: 'converting' stamp: 'lr 10/3/2006 14:32'!
asAnnouncement
	^ self! !

!Announcement methodsFor: '*announcements-view' stamp: 'lr 9/3/2006 16:17'!
open
	self inspect! !

Announcement subclass: #AnnouncementMockA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests'!

Announcement subclass: #AnnouncementMockB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests'!

AnnouncementMockB subclass: #AnnouncementMockC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests'!

Object subclass: #AnnouncementSpy
	instanceVariableNames: 'announcer announcements index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-View'!

!AnnouncementSpy class methodsFor: 'instance-creation' stamp: 'lr 6/14/2006 17:05'!
on: anAnnouncer
	^ self new
		announcer: anAnnouncer;
		yourself! !

!AnnouncementSpy class methodsFor: 'instance-creation' stamp: 'lr 6/14/2006 17:05'!
openOn: anAnnouncer
	ToolBuilder open: (self on: anAnnouncer)! !

!AnnouncementSpy methodsFor: 'private' stamp: 'lr 9/3/2006 14:09'!
announce: anAnnouncement
	self announcements add: anAnnouncement.
	self index: self announcements size.
	self changed: #announcements! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 6/14/2006 17:02'!
announcements
	^ announcements! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 9/3/2006 14:08'!
announcements: aCollection
	announcements := aCollection.
	self changed: #announcements! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 6/14/2006 17:04'!
announcer
	^ announcer! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 9/25/2006 09:26'!
announcer: anAnnouncer
	announcer ifNotNil: [ announcer unsubscribe: self ].
	announcer := anAnnouncer.
	announcer ifNotNil: [ announcer subscribe: Announcement send: #announce: to: self ]! !

!AnnouncementSpy methodsFor: 'building' stamp: 'lr 9/3/2006 16:21'!
buildMenu: aMenuMorph
	^ aMenuMorph
		defaultTarget: self;
		add: 'open' action: #open;
		add: 'clear' action: #clear;
		yourself! !

!AnnouncementSpy methodsFor: 'building' stamp: 'lr 9/25/2006 09:20'!
buildWith: aBuilder
	^ aBuilder build: (aBuilder pluggableWindowSpec new
		model: self; 
		label: self label; 
		extent: self extent;
		closeAction: #close;
		children: (OrderedCollection new
			add: (aBuilder pluggableListSpec new
				model: self;
				list: #announcements;
				menu: #buildMenu:;
				getIndex: #index;
				setIndex: #index:;
				frame: (0 @ 0 corner: 1 @ 1);
				yourself);
			yourself);
		yourself)! !

!AnnouncementSpy methodsFor: 'private' stamp: 'lr 6/14/2006 17:19'!
changed: aSymbol
	WorldState addDeferredUIMessage: [ super changed: aSymbol ]! !

!AnnouncementSpy methodsFor: 'actions' stamp: 'lr 9/3/2006 16:21'!
clear
	self announcements: OrderedCollection new! !

!AnnouncementSpy methodsFor: 'actions' stamp: 'lr 9/25/2006 09:19'!
close
	self announcer: nil! !

!AnnouncementSpy methodsFor: 'accessing-dynamic' stamp: 'lr 9/3/2006 14:08'!
extent
	^ 250 @ 400! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 6/14/2006 17:02'!
index
	^ index ! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 6/14/2006 17:20'!
index: anInteger
	index := anInteger.
	self changed: #index! !

!AnnouncementSpy methodsFor: 'initialization' stamp: 'lr 6/14/2006 17:03'!
initialize
	super initialize.
	self announcements: OrderedCollection new.
	self index: 0! !

!AnnouncementSpy methodsFor: 'accessing-dynamic' stamp: 'lr 6/14/2006 17:03'!
label
	^ self announcer printString! !

!AnnouncementSpy methodsFor: 'actions' stamp: 'lr 9/25/2006 09:25'!
open
	(self announcements at: self index ifAbsent: [ ^ self ]) 
		open! !

!AnnouncementSpy methodsFor: 'private' stamp: 'lr 6/14/2006 17:29'!
perform: selector orSendTo: otherTarget
	^ (self respondsTo: selector)
		ifTrue: [ self perform: selector ]
		ifFalse: [ super perform: selector orSendTo: otherTarget ]! !

Object subclass: #Announcer
	instanceVariableNames: 'subscriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!Announcer methodsFor: 'announce' stamp: 'lr 8/5/2008 12:06'!
announce: anAnnouncement
	| announcement |
	announcement := anAnnouncement asAnnouncement.
	subscriptions ifNil: [ ^ announcement ].
	subscriptions keysAndValuesDo: [ :class :actions |
		(class handles: announcement) 
			ifTrue: [ actions valueWithArguments: (Array with: announcement) ] ].
	^ announcement! !

!Announcer methodsFor: 'convenience' stamp: 'lr 10/27/2006 14:26'!
on: anAnnouncementClass do: aValuable
	^ self subscribe: anAnnouncementClass do: aValuable! !

!Announcer methodsFor: 'convenience' stamp: 'lr 10/27/2006 14:27'!
on: anAnnouncementClass send: aSelector to: anObject
	^ self subscribe: anAnnouncementClass send: aSelector to: anObject! !

!Announcer methodsFor: '*announcements-view' stamp: 'lr 9/20/2006 08:18'!
open
	AnnouncementSpy openOn: self! !

!Announcer methodsFor: 'subscription' stamp: 'lr 8/5/2008 12:05'!
subscribe: anAnnouncementClass do: aValuable 
	| actions |
	subscriptions ifNil: [ subscriptions := IdentityDictionary new ].
	actions := subscriptions at: anAnnouncementClass ifAbsent: [ ActionSequence new ].
	subscriptions at: anAnnouncementClass put: (actions copyWith: aValuable).
	^ aValuable! !

!Announcer methodsFor: 'subscription' stamp: 'lr 10/27/2006 14:27'!
subscribe: anAnnouncementClass send: aSelector to: anObject
	^ self subscribe: anAnnouncementClass do: (MessageSend receiver: anObject selector: aSelector)! !

!Announcer methodsFor: 'subscription' stamp: 'lr 8/5/2008 12:05'!
unsubscribe: anObject
	subscriptions ifNil: [ ^ self ].
	subscriptions keysAndValuesDo: [ :class :actions |
		subscriptions at: class put: (actions 
			reject: [ :each | each receiver == anObject ]) ].
	subscriptions keysAndValuesRemove: [ :class :actions |
		actions isEmpty ]! !

!Announcer methodsFor: 'convenience' stamp: 'tg 2/25/2009 12:05'!
when: anAnnouncementClass do: aValuable
	^ self subscribe: anAnnouncementClass do: aValuable! !

TestCase subclass: #AnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests'!

!AnnouncerTest methodsFor: 'running' stamp: 'lr 9/25/2006 08:42'!
setUp
	announcer := Announcer new! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:11'!
testAnnounceClass
	self assert: (announcer announce: AnnouncementMockA) 
		class = AnnouncementMockA! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:10'!
testAnnounceInstance
	| instance |
	instance := AnnouncementMockA new.
	self assert: (announcer announce: instance) = instance! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:08'!
testSubscribeBlock
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:07'!
testSubscribeSend
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA
		send: #value:
		to: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:07'!
testSubscribeSet
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA , AnnouncementMockC
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement isNil.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockC.
	self assert: announcement = instance! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:06'!
testSubscribeSubclass
	| announcement instance |
	announcer
		subscribe: AnnouncementMockB
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement isNil.

	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockC.
	self assert: announcement = instance.! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:10'!
testUnsubscribeBlock
	| announcement |
	announcer
		subscribe: AnnouncementMockA
		do: [ :ann | announcement := ann ].
	announcer
		unsubscribe: self.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:13'!
testUnsubscribeSend
	| announcement receiver |
	announcer
		subscribe: AnnouncementMockA
		send: #value:
		to: (receiver := [ :ann | announcement := ann ]).
	announcer
		unsubscribe: receiver.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:13'!
testUnsubscribeSet
	| announcement |
	announcer
		subscribe: AnnouncementMockA , AnnouncementMockB
		do: [ :ann | announcement := ann ].
	announcer
		unsubscribe: self.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil.
	
	announcement := nil.
	announcer announce: AnnouncementMockB new.
	self assert: announcement isNil.! !
